#@title Default title text
# -*- coding: utf-8 -*-
"""ANN

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1cqGRYjTD8D5VRektwaWjZOaRwKEXQpyR
"""



import numpy as np 
import pandas as pd
import tensorflow as tf


dataset = pd.read_csv("train_all.csv")

X = dataset.iloc[:, 1:4].values
Y = dataset.iloc[:, -1].values

from sklearn.model_selection import train_test_split
x_train, x_test, y_train, y_test = train_test_split(X, Y, test_size = 0.2)



from keras.utils import np_utils
from keras.layers import Input, Dense, Dropout
from keras.models import Model
from keras.callbacks import ModelCheckpoint

saved_weights_name='ANNWeights.h5'

num_classes = 3

y_train = np_utils.to_categorical(y_train, num_classes)
print ("y_train:", y_train.shape)

print ("x_train:",x_train.shape)

inp = Input(shape=(3,))
hidden_1 = Dense(1024, activation='relu')(inp)
dropout_1 = Dropout(0.2)(hidden_1)
out = Dense(num_classes, activation='softmax')(hidden_1) 
model = Model(input=inp, output=out)






checkpoint = ModelCheckpoint(saved_weights_name, 
                                     monitor='val_acc', 
                                     verbose=1, 
                                     save_best_only=True, 
                                     mode='max')

model.compile(loss='categorical_crossentropy', # using the cross-entropy loss function
              optimizer='adam', # using the Adam optimiser
              metrics=['accuracy']) # reporting the accuracy

model.fit(x_train, y_train, # Train the model using the training set...
          batch_size=500, nb_epoch=5,
          verbose=1, validation_split=0.1,
         callbacks=[checkpoint]) # ...holding out 10% of the data for validation


y_test = np_utils.to_categorical(y_test, num_classes)
print ("y_test:", y_test.shape)


print ("x_test:",x_train.shape)
print(model.evaluate(x_test, y_test, verbose=1)) # Evaluate the trained model on the test set!


# Create & upload a file.
uploaded = drive.CreateFile({'title':saved_weights_name})
uploaded.SetContentFile(saved_weights_name)
uploaded.Upload()
print('Uploaded file with ID {}'.format(uploaded.get('id')))



